; 
    include \masm32\include\masm32rt.inc
; 

    ;---------------------------------------------------------------
    ; This extends the MASM32 dialog macros to do modeless dialogs.
    ; NOTE THAT THIS HAS BEEN ADDED TO MASM32 V10
    ;---------------------------------------------------------------

    CallModelessDialog MACRO Instance,Parent,DlgProc,lParamInit

      invoke CreateDialogIndirectParam,Instance,esi,Parent,
                                       ADDR DlgProc,lParamInit
      push eax                ;; preserve return value
      invoke GlobalFree,esi   ;; free memory
      pop eax                 ;; restore return value
      pop edi
      pop esi

    ENDM

; 
    .data
      hDlg      dd 0
      hDC       dd 0
      hBrush    dd 0
      color     dd 0
      px        dd 0
      py        dd 0
      msg       MSG <>
      rc        RECT <>

      cong_seed dd 380116160

    .code
; 

align 4

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

congb proc base:DWORD

    mov eax, cong_seed
    mov ecx, 69069
    mul ecx
    add eax, 1234567
    mov cong_seed, eax
    mov ecx, [esp+4]
    mul ecx
    mov eax, edx
    ret 4

congb endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

DlgProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke GetDC, hwndDlg
        mov  hDC, eax

        invoke GetStockObject, WHITE_BRUSH
        mov hBrush, eax

      CASE WM_CTLCOLORDLG

        return hBrush

      CASE WM_SIZE

        invoke GetClientRect, hwndDlg, ADDR rc
        invoke FillRect, hDC, ADDR rc, hBrush

      CASE WM_COMMAND

        SWITCH wParam

          CASE IDCANCEL

            invoke DestroyWindow, hwndDlg

        ENDSW

      CASE WM_CLOSE

        invoke DestroyWindow, hwndDlg

      CASE WM_DESTROY

        invoke PostQuitMessage, NULL

    ENDSW

    return 0

DlgProc endp
; 
start:
; 

    Dialog  "Test", \                         ; caption
            "Courier New Bold", 10, \         ; font,pointsize
            WS_OVERLAPPEDWINDOW or \          ; window style
            WS_VISIBLE or DS_CENTER, \
            0, \                              ; number of controls
            0,0,200,150, \                    ; x, y, width, height
            1024                              ; memory buffer size

    invoke GetModuleHandle, NULL
    CallModelessDialog eax, 0, DlgProc, NULL
    mov hDlg, eax

  msgLoop:

    invoke PeekMessage, ADDR msg, NULL, 0, 0, PM_REMOVE
    .IF eax
      .IF msg.message == WM_QUIT
        jmp @F
      .ENDIF
      invoke IsDialogMessage, hDlg, ADDR msg
    .ELSE
      invoke congb, 0ffffffh
      mov color, eax
      invoke congb, rc.right
      mov px, eax
      invoke congb, rc.bottom
      mov py, eax
      invoke SetPixel,hDC,px,py,color
    .ENDIF
    jmp msgLoop

  @@:

    exit
; 
end start
