; 
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm
; 
    .data
      counts dd 10 dup(0)
    .code
; 

;--------------------------------------------------------
; This is an asm implementation of a simple congruential
; generator by George Marsaglia.
;--------------------------------------------------------

.data
    cong_seed dd 380116160
.code

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

cong proc
    mov eax, cong_seed
    mov ecx, 69069
    mul ecx
    add eax, 1234567
    mov cong_seed, eax
    ret
cong endp

; 

;----------------------------------------------------------
; This is the above generator with a base parameter added,
; performing the mod operation with a multiply.
;----------------------------------------------------------

align 4

congb proc base:DWORD
    mov eax, cong_seed
    mov ecx, 69069
    mul ecx
    add eax, 1234567
    mov cong_seed, eax
    mov ecx, [esp+4]
    mul ecx
    mov eax, edx
    ret 4
congb endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

;----------------------------------------------------------
; This is the above generator with a base parameter added,
; performing the mod operation with a division.
;----------------------------------------------------------

align 4

congb2 proc base:DWORD
    mov eax, cong_seed
    mov ecx, 69069
    mul ecx
    xor edx, edx
    add eax, 1234567
    mov cong_seed, eax
    div dword ptr [esp+4]
    mov eax, edx
    ret 4
congb2 endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 
start:
; 

    ;----------------------
    ; A quick visual test.
    ;----------------------

    mov ebx, 1000
    .WHILE ebx
      invoke congb, 0100h
      print uhex$(eax),9
      dec ebx
    .ENDW

    print chr$(13,10)
    inkey
    print chr$(13,10)

    ;-----------------------------------
    ; A quick test of the distribution.
    ;-----------------------------------

    mov ebx, 100000000
    .WHILE ebx
      invoke congb, 10
      inc DWORD PTR counts[eax*4]
      dec ebx
    .ENDW
    print ustr$(counts),13,10
    print ustr$(counts+4),13,10
    print ustr$(counts+8),13,10
    print ustr$(counts+12),13,10
    print ustr$(counts+16),13,10
    print ustr$(counts+20),13,10
    print ustr$(counts+24),13,10
    print ustr$(counts+28),13,10
    print ustr$(counts+32),13,10
    print ustr$(counts+36),13,10

    print chr$(13,10)
    inkey
    print chr$(13,10)

    invoke Sleep, 3000

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke nrandom, 100
    counter_end
    print ustr$(eax)," cycles, nrandom",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke crt_rand
    counter_end
    print ustr$(eax)," cycles, crt_rand",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke cong
    counter_end
    print ustr$(eax)," cycles, cong",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke congb, 100
    counter_end
    print ustr$(eax)," cycles, congb",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke congb2, 100
    counter_end
    print ustr$(eax)," cycles, congb2",13,10,13,10

    inkey "Press any key to exit..."
    exit
; 
end start
